/*! \file dstring.h
    Header file for dstring.c
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef DSTRING_HEADER

  #include <sys/types.h>

  /*! \brief Data structure that defines a dynamic string.
   */

  struct s_dstring {
                     /*! \brief Pointer to the start of the data. */
                     char        *data;

                     /*! \brief Total number of bytes allocated for the data. */
                     size_t      size;

                     /*! \brief Number of characters in the string. */
                     size_t      nb_car;
                   };

  /*! \brief Data type for dynamic string.
   */

  typedef struct s_dstring dstring;

  int dstring_init (dstring *s, size_t init_size);
  void dstring_free (dstring *s);
  int dstring_add (dstring *s, char *buff, size_t nb_elem);
  char* dstring_get_data (dstring *s, size_t *size);

#define DSTRING_HEADER
#endif

#ifdef __cplusplus
}
#endif

