/*! \file sort.h
    Header file for qksort.c
 */

#ifndef SORT_HEADER

#ifdef __cplusplus
extern "C" {
#endif

int issort (
              void *donnee,
              int  nb_elts,
              int  taille_elt,
              int  (*compare)(const void *cle1, const void *cle2)
           );

int extended_issort (
                      void  *donnee,
                      int   nb_elts,
                      int   taille_elt,
                      int   (*compare)(const void *cle1, const void *cle2),
                      int   (*copy_data)(void *src, void *dest),
                      int   (*init_elem)(void *elm)
                    );

int qksort (
             void *donnee,
             int  nb_elts,
             int  taille_elt,
             int  i,
             int  k,
             int  (*compare)(const void *cle1, const void *cle2)
           );

int extended_qksort (
                      void  *donnee,
                      int   nb_elts,
                      int   taille_elt,
                      int   i,
                      int   k,
                      int   (*compare)(const void *cle1, const void *cle2),
                      int   (*copy_data)(void *src, void *dest),
                      int   (*init_elem)(void *elm)
                    );



#ifdef __cplusplus
}
#endif

#define SORT_HEADER
#endif
