#!/sbin/sh
#*==========================================================================*
# Procedure d insertion asynchrone de tickets a partir des logs tsm 
# Fait par Kader
# date 23:03:2001
# maj : le 9/8/2001
#
#*==========================================================================*
#  Le fichier .log.gz doit se trouver initialement zipe dans /oracle/backup/tsmlog
# Le $1 = {mois}{jours} 
# Le $2 = <ENTITE> : lt ou freesbee
# Le $3 = CHAINE> :	1 pour la chaine de traitement scripts1
# 							2 pour la chaine de traitement scripts2

#
usage () {
cat << EOF

Usage : ./lnap.sh [ <{mois}{jours}> <ENTITE> <Num CHAINE>]
  (ex : ./lnap.sh 0802 freesbee 2 )

Le plus recent des lt sur $REP_TSM est : 
		`ls -tr $REP_TSM/b-tsm-200*-radius-accounting_lt.log.gz | tail -1  2> /dev/null`
		`ls -tr $REP_TSM/b-tsm3-200*-radius-accounting_freesbee.log.gz | tail -1 2> /dev/null` 
		`ls -tr $REP_TSM/b-tsm4-200*-radius-accounting_worldonline_fft.log.gz | tail -1  2> /dev/null `

EOF
        exit 1
}

##*********************************************************************************************
# saisie
##*********************************************************************************************
saisie()
{
clear
echo "
*****************************************************
lt    freesbee   worldonline_fft 
*****************************************************

Saisir une entite: \c"
read ENTITE

echo " 


*****************************************************
  1. Chaine 1
  2. Chaine 2
*****************************************************
Saisir une chaine : \c"
read CHAINE
echo "chaine $CHAINE"


ls -tr $REP_TSM/$ENTITE
echo "


Saisir sur la meme ligne les 2 fichiers a traiter (extention log ou log.gz):
\c"
read liste_fichiers
echo $liste_fichiers

clear
echo "
Rejouer les tickets de $ENTITE sur chaine $CHAINE des fichiers:"
echo
echo "$liste_fichiers" | sed 's/ /\
/g' 

echo "
*****************************************************
Continuer (o/n): \c"

read choix
case $choix in
	o|O) return;;
	*) exit 0;;
esac
}

#*********************************************************************************************
# Main 
#*********************************************************************************************
set -x
REP_TSM=/oracle/backup/tsmlog
REP_INFRA=/export/admin/infranet
TEMP=$REP_TSM/temp
Log=$REP_INFRA/log/$0."$Days"
DEJA_TRAITE=$REP_TSM/deja_traite
HEURE=`date '+%H'`
DATE=`date '+%m%d'`
Happy_Days=`date '+%m%d%H%M%S'`
Host=`hostname`
Owner="bsslsurf"

# Saisie des variables
saisie
# Fin Saisie

REP_WORK=/export/admin/infranet/scripts$CHAINE

echo "\n date debut : `date`"
echo "************************************************\n"

# Se positionner dans le bon repertoire $CHAINE ( scripts1 ou 2)
#===============================================================
cd $REP_WORK 

# Traitement principal
#=============================
echo " Libere l'espace des logs dans scripts$CHAINE :"
echo "************************************************\n"
rm $REP_WORK/nap*/default.pinlog > /dev/null
rm $REP_WORK/nap*/*.nap > /dev/null
rm $REP_WORK/log/*err > /dev/null 
rm $REP_WORK/log/*log > /dev/null
rm $REP_WORK/rejets/*bad > /dev/null
rm $REP_WORK/nohup.out > /dev/null

# prepare fic en foction de la date : unzip + cat de tsm3+tsm4 puis gzip des fichiers initiaux
#---------------------------------------------------------------------------------------------
echo "\n Prepare fichiers : unzip des fichiers + cat de tsm3+tsm4 .."
echo "***********************************************************\n"

for fic in $liste_fichiers
do
gunzip $REP_TSM/$ENTITE/$fic > /dev/null
done

FICHIER_TSM=b-tsm-${ENTITE}_${CHAINE}_$Happy_Days
FICHIER=`echo $liste_fichiers |awk '{print $1}'` 
FICHIER_TSM3=`basename $FICHIER .gz`
FICHIER=`echo $liste_fichiers |awk '{print $2}'` 
FICHIER_TSM4=`basename $FICHIER .gz`

cat $REP_TSM/$ENTITE/$FICHIER_TSM3  $REP_TSM/$ENTITE/$FICHIER_TSM4 >> $TEMP/$FICHIER_TSM
[ $? -ne 0 ] && echo "Echec du cat pour generer $TEMP/$FICHIER_TSM" && exit 1

# Formatage du fichier   log en fic .dat trie par login
#-------------------------------------------------------
echo "\n Formatage du $FICHIER_TSM : Conversion  en .dat + sort .."
echo " ************************************************************************\n"

./pre_process_import.pl $TEMP/$FICHIER_TSM > $TEMP/${FICHIER_TSM}.tri

rm $TEMP/$FICHIER_TSM 
[ $? -ne 0 ] && echo "Echec rm $TEMP/$FICHIER_TSM" && exit 1

# tri des tickets
sort -t ";" -k 2 $REP_TSM/temp/${FICHIER_TSM}.tri > $REP_WORK/data/${FICHIER_TSM}.dat
rm $REP_TSM/temp/${FICHIER_TSM}.tri
[ $? -ne 0 ] && echo "Echec rm $REP_TSM/temp/${FICHIER_TSM}.tri" && exit 1

Fichier="${FICHIER_TSM}.dat"

#########
#exit 0
########

#  decoupage en 10 fic de  J lignes
#------------------------------------
Lines=`wc -l data/$Fichier | awk '{ print $Fichier}'` 
echo " Nb de linges a inserer est de : $Lines"
echo " **********************************************************************\n"

J0=`echo $Lines | awk '{print $1"/10"}' | bc`
J=`echo "$J0 + 1" | bc`

echo " Decomposition en 10 Fichiers  .nap "
echo "***************************************\n"
echo " ./pp_uel.pl -c$J $Fichier \n"

./pp_uel.pl -c$J $Fichier

# prepare les 10 lnap a lancer
#-----------------------------
echo "\n Remise des fichiers .nap dans les rep nap"
echo " ********************************************\n"
ls nap*/*nap > List.$$ 

z=1
while read fichier
do

	echo " mv $fichier  nap$z/ "
	mv $fichier  nap$z/
	[ $? -ne 0 ] && echo "Echec mv du $fichier dans nap$z" && exit 1
	z=`echo "$z + 1" | bc`
	if [ $z -gt "10" ]
	then
	z=1
	fi
done < List.$$

rm List.$$
[ $? -ne 0 ] && echo "Echec rm de List.$$"

mv nap1/*nap nap/
[ $? -ne 0 ] && echo "Echec mv du nap1/*nap dans nap" && exit 1

#########
#echo $Fichier
#exit 0
########
#--------------------
# Lancement du 1er lnap
#----------------------
echo "\n Lancement en background du 1er lnap .."
echo "*******************************************\n"

	echo " nohup lnap.pl $Fichier &"
	nohup ./lnap.pl $Fichier &
	[ $? -ne 0 ] && echo "Echec du nohup ./lnap.pl $Fichier &" && exit 1

# Lancement des 10 lnap suivants + mv de tout les fic .dat
#---------------------------------------------------------
echo "\n Lancement en background des 9 lnap avec un delta d attente de 5s.."
echo " *******************************************************************\n"
Compteur=2

while [ $Compteur -le 10 ]; do
	sleep 5

	echo " nohup lnap$Compteur.pl $Fichier &"
	echo " ********************************************\n"
	nohup ./lnap$Compteur.pl $Fichier &
	[ $? -ne 0 ] && echo "Echec du nohup ./lnap$Compteur.pl $Fichier &" && exit 1

	#	Pid$Compteur=$!

	Compteur=`echo "$Compteur + 1" | bc`

done

#Post traitement
#===============
rm $REP_WORK/data/${FICHIER_TSM}.dat
[ $? -ne 0 ] && echo "Echec du rm $REP_WORK/data/${FICHIER_TSM}.dat "

mv $REP_TSM/$ENTITE/$FICHIER_TSM3 $DEJA_TRAITE 
[ $? -ne 0 ] && echo "Echec du mv $REP_TSM/$ENTITE/$FICHIER_TSM3 $DEJA_TRAITE" && exit 1

mv $REP_TSM/$ENTITE/$FICHIER_TSM4 $DEJA_TRAITE 
[ $? -ne 0 ] && echo "Echec du mv $REP_TSM/$ENTITE/$FICHIER_TSM4 $DEJA_TRAITE" && exit 1

echo "\ndate Fin : `date`"
