#!/usr/local/bin/perl
######!/bin/perl

use FileHandle;
use Text::Tabs;
use Date::Manip;

if ($#ARGV != 0)
 {
  print "Usage : $0 < radius log file to process >\n";
  exit 1;
 }

my %ref_table = (
	"User-Name" => "0", 
	"NAS-IP-Address" => 1,
	"Ascend-Unknown-86" => 2,
	"NAS-Port" => 3,
	"Ascend-Unknown-13" => 4,
	"NAS-Port-Type" => 5,
	"Class" => 6,
	"Acct-Status-Type" => 7,
	"Acct-Delay-Time" => 8,
	"Acct-Session-Id" => 9,
	"Acct-Authentic" => 10,
	"Acct-Session-Time" => 11,
	"Acct-Input-Octets" => 12,
	"Acct-Output-Octets" => 13,
	"Acct-Input-Packets" => 14,
	"Acct-Output-Packets" => 15,
	"Disconnect-Cause" => 16,
	"Ascend-Disconnect-Cause" => 16,
	"Connect-Progress" => 17,
	"Ascend-Connect-Progress" => 17,
	"Xmit-Rate" => 18,
	"Ascend-Xmit-Rate" => 18,
	"Data-Rate" => 19,
	"Ascend-Data-Rate" => 19,
	"PreSession-Time" => 20,
	"Ascend-PreSession-Time" => 20,
	"Pre-Input-Octets" => 21,
	"Ascend-Pre-Input-Octets" => 21,
	"Pre-Output-Octets" => 22,
	"Ascend-Pre-Output-Octets" => 22,
	"Pre-Input-Packets" => 23,
	"Ascend-Pre-Input-Packets" => 23,
	"Pre-Output-Packets" => 24,
	"Ascend-Pre-Output-Packets" => 24,
	"First-Dest" => 25,
	"Ascend-First-Dest" => 25,
	"Modem-PortNo" => 26,
	"Ascend-Modem-PortNo" => 26,
	"Modem-SlotNo" => 27,
	"Ascend-Modem-SlotNo" => 27,
	"Modem-ShelfNo" => 28,
	"Ascend-Modem-ShelfNo" => 28,
	"Calling-Station-Id" => 29,
	"Called-Station-Id" => 30,
	"Framed-Protocol" => 31,
	"Framed-IP-Address" => 32,
	"Pseudo-Request-Source" => 33,
	"Pseudo-Request-Type" => 34,);
	
my %ref_month = (
	"Jan"	=> 1,
	"Feb"	=> 2,
	"Mar"	=> 3,
	"Apr"	=> 4,
	"May"	=> 5,
	"Jun"	=> 6,
	"Jul"	=> 7,
	"Aug"	=> 8,
	"Sep"	=> 9,
	"Oct"	=> 10,
	"Nov"	=> 11,
	"Dec"	=> 12,);

%ref_disc_cause = (
	"noModemLossCarrier"	=> 11,
	"pppRcvTerminate"	=> 45,
	"remoteEndHungup"	=> 185,
	"sessTimeOut"		=> 100, );

my @ref_array = ("") x 36;

my $toprint = 0;

my($TmpsCtrl)= time();

my $fi = new FileHandle;

$fi->open("< $ARGV[0]");

while (!eof($fi))
 {
  my $line = $fi->getline();

  chomp($line);

  if (length($line) > 0)
   {
    $toprint = 0;

    my @data = split(/ = /, $line);

    my @att = split(/\t/, $data[0]);

    $attr = $att[1];

    if (scalar(@data) == 1)
     {
# print STDERR "\nDatus[".$line."]\n";

      # Mon Aug 06 01:00:26 MET DST 2001

      my($m,$d,$y,$h,$mn, $s)=0;

      if( $line =~ /(\w+)\s(\w+)\D+(\d+)\s(\d+):(\d+):(\d+)\s(\w+)\s(\w+)\s(\d+)$/)
		{
		   $m = $ref_month{$2}; 
         $d = $3;
         $y = $9;
         $h = $4;
         $mn =$5;
         $s = $6;
      }
		 if($7 ne "MET")
	     {
          print STDERR "\n Erreur Format Date et Heure => TimeZone [".$7."] different de Met \n\a";
          print STDERR "\n A> [$line]\n";
          exit(0);
        }

	    if( ($h<0) || ($h>24) || ($mn>60) || ($s>60) || ($d>31) || ($y<1990) || ($m>12) )
        {
            print STDERR "\n Format date et heure du Ticket incorrect....\a\n";
            print STDERR "\n A> [$line]\n";
				exit(0);
        }


#      my @info = split (/ /, $line);
#      my $m = $ref_month{$info[1]};
#      my $d = $info[2];
#      my $y = $info[scalar(@info) - 1] ;
#      my ($h, $mn, $s) = split(/:/, $info[3]);

      $date=&Date_SecsSince1970GMT($m,$d,$y,($h-1),$mn,$s);

      if( $date > $TmpsCtrl )
		{
            print STDERR "\n[ERREUR Date et heure ] Ticket posterieur a date d aujourd hui !!\a\n";
            print STDERR "\n A> [$line]\n";
            exit(0);
		}

      #printf STDERR "%s/%s/%s %d:%d:%d\n", $m, $d, $y, $h, $mn, $s;

     }
    elsif (exists $ref_table{$att[1]})
     {
      $ref_array[$ref_table{$att[1]}] = $data[1];
     }
   }
  elsif (!$toprint)
   {
    $string_to_print = "$date;$ref_array[0];$ref_array[1];".
    		       "$ref_array[3];";

    for ($field = 5; $field < 34; $field++)
     {
      if (($field == 16) && exists($ref_disc_cause{$ref_array[$field]}))
       {
        $string_to_print .= "$ref_disc_cause{$ref_array[$field]};";
       }
      elsif ($field == 32)
       {
        my @ipaddr = split('\.', $ref_array[$field]);

        $string_to_print = sprintf "%s%.2X%.2X%.2X%.2X;", $string_to_print,
			  		          	  $ipaddr[0],
			      			  	  $ipaddr[1],
			      			  	  $ipaddr[2],
			      			  	  $ipaddr[3];
       }
      else
       {
        $string_to_print .= "$ref_array[$field];";
       }
     }

    if ($ref_array[$ref_table{"Acct-Status-Type"}] ne "Alive")
     {
      print "$string_to_print$ref_array[34]\n";
     }

    $toprint = 1;

    for ($field = 0; $field < 35; $field++)
     {
      $ref_array[$field] = "";
     }
   }
 }

close($fi);

exit 0;
