%{

#include <stdio.h>
#include <string.h>
#include "strings_utils.h"
#include "chtbl.h"

#define PRIVATE_CODE_ONLY
#include "config.h"
#undef PRIVATE_CODE_ONLY



int configwrap() { return 1; }



static struct fields    fd;
static int              n;
static struct user_data *ud;
extern CHTbl htab;

%}

SPACE         \x20
TABUL         \t
BLANK         [\x20\t]
NUMBER        [0-9]
INTEGER       {NUMBER}+
BLANK_LINE    ^{BLANK}+\n
COMMENT       ^{BLANK}*#.+\n
EMPTY_LINE    ^\n

TAG           [0-9a-zA-Z\-_]+
CONF          ^{TAG}{BLANK}*=.+$



%%

{CONF}       {
               /* ---------------------------------------------- */
               /* Split couple (tag = value)                     */
               /* ---------------------------------------------- */

               n = s_split_exact (yytext, "=", &fd); 
               if (n == -1) { return CONF_PARSER_NO_MEM; }

               if (fd.number_of_fields != 2) { return CONF_PARSER_SYNTAX_ERROR; }

               /* ---------------------------------------------- */
               /* Remove spaces                                  */
               /* ---------------------------------------------- */

               if (chop(fd.tabs[0]) == NULL) { return CONF_PARSER_NO_MEM; }
               if (chop(fd.tabs[1]) == NULL) { return CONF_PARSER_NO_MEM; }

               /* ---------------------------------------------- */
               /* Allocate hash table element                    */
               /* ---------------------------------------------- */

               ud = malloc(sizeof(struct user_data));
               if (ud == NULL) { return CONF_PARSER_NO_MEM; }

               ud->tag = malloc(strlen(fd.tabs[0])+1);
               if (ud->tag == NULL) { return CONF_PARSER_NO_MEM; }

               ud->value = malloc(strlen(fd.tabs[1])+1);
               if (ud->value == NULL) { return CONF_PARSER_NO_MEM; }

               /* ---------------------------------------------- */
               /* Set hash table element                         */
               /* ---------------------------------------------- */

               strcpy (ud->tag,   fd.tabs[0]);
               strcpy (ud->value, fd.tabs[1]);

               free_fields(&fd);

               /* ---------------------------------------------- */
               /* Add element to the hash                        */
               /* ---------------------------------------------- */

               n = chtbl_insert (&htab, (void*)ud);

               if (n == -1) { return CONF_PARSER_NO_MEM; }

               if (n ==  1) { return CONF_PARSER_DUPLICATED_TAG; } 
             }


{BLANK_LINE} {  }
{EMPTY_LINE} {  }
{COMMENT}    {  }
\n           {  }
.*           { return CONF_PARSER_SYNTAX_ERROR; }

%%



