#include <stdio.h>

int main (int argc, char* argv[])
{
  FILE *fd;

  if (argc != 2)
  {
    fprintf (stderr, "\nUsage: os_specific <output file>\n");
    return 1;
  }

  fd = fopen (argv[1], "w");
  if (fd == NULL)
  {
    fprintf (stderr, "\nos_specific can not open output file %s\n", argv[1]);
    return 1;
  }  

  fprintf (fd, "\n#ifndef DATA_STORAGE_SIZE_HD");

  /* --------------------------------------------------------------- */
  /*                              Scalar types                       */
  /* --------------------------------------------------------------- */

  fprintf (fd, "\n#define INT_SIZE                        %d", sizeof(int));
  fprintf (fd, "\n#define CHAR_SIZE                       %d", sizeof(char));
  fprintf (fd, "\n#define FLOAT_SIZE                      %d", sizeof(float));
  fprintf (fd, "\n#define DOUBLE_SIZE                     %d", sizeof(double));
  fprintf (fd, "\n#define SIGNED_INT_SIZE                 %d", sizeof(signed int));
  fprintf (fd, "\n#define SIGNED_CHAR_SIZE                %d", sizeof(signed char));
  fprintf (fd, "\n#define UNSIGNED_INT_SIZE               %d", sizeof(unsigned int));
  fprintf (fd, "\n#define UNSIGNED_CHAR_SIZE              %d", sizeof(unsigned char));
  fprintf (fd, "\n#define SHORT_INT_SIZE                  %d", sizeof(short int));
  fprintf (fd, "\n#define UNSIGNED_SHORT_INT_SIZE         %d", sizeof(unsigned short int));
  fprintf (fd, "\n#define SIGNED_SHORT_INT_SIZE           %d", sizeof(signed short int));
  fprintf (fd, "\n#define LONG_INT_SIZE                   %d", sizeof(long int));
  fprintf (fd, "\n#define LONG_DOUBLE_SIZE                %d", sizeof(long double));
  fprintf (fd, "\n#define UNSIGNED_LONG_INT_SIZE          %d", sizeof(unsigned long int));
  fprintf (fd, "\n#define SIGNED_LONG_INT_SIZE            %d", sizeof(signed long int));

  /* --------------------------------------------------------------- */
  /*                           Pointer types                         */
  /* --------------------------------------------------------------- */

  fprintf (fd, "\n#define PTR_INT_SIZE                    %d", sizeof(int*));
  fprintf (fd, "\n#define PTR_CHAR_SIZE                   %d", sizeof(char*));
  fprintf (fd, "\n#define PTR_FLOAT_SIZE                  %d", sizeof(float*));
  fprintf (fd, "\n#define PTR_DOUBLE_SIZE                 %d", sizeof(double*));
  fprintf (fd, "\n#define PTR_SIGNED_INT_SIZE             %d", sizeof(signed int*));
  fprintf (fd, "\n#define PTR_SIGNED_CHAR_SIZE            %d", sizeof(signed char*));
  fprintf (fd, "\n#define PTR_UNSIGNED_INT_SIZE           %d", sizeof(unsigned int*));
  fprintf (fd, "\n#define PTR_UNSIGNED_CHAR_SIZE          %d", sizeof(unsigned char*));
  fprintf (fd, "\n#define PTR_SHORT_INT_SIZE              %d", sizeof(short int*));
  fprintf (fd, "\n#define PTR_UNSIGNED_SHORT_INT_SIZE     %d", sizeof(unsigned short int*));
  fprintf (fd, "\n#define PTR_SIGNED_SHORT_INT_SIZE       %d", sizeof(signed short int*));
  fprintf (fd, "\n#define PTR_LONG_INT_SIZE               %d", sizeof(long int*));
  fprintf (fd, "\n#define PTR_LONG_DOUBLE_SIZE            %d", sizeof(long double*));
  fprintf (fd, "\n#define PTR_UNSIGNED_LONG_INT_SIZE      %d", sizeof(unsigned long int*));
  fprintf (fd, "\n#define PTR_SIGNED_LONG_INT_SIZE        %d", sizeof(signed long int*));

  fprintf (fd, "\n#define DATA_STORAGE_SIZE_HD");
  fprintf (fd, "\n#endif");

  fclose (fd);
  return 0;
}
