/*! \file rand_dates.c
    This is just a simple utility used to generate random dates ... It can be used for testing the function that
    converts dates into timestamps.
 */


#include <time.h>
#include <stdio.h>
#include <stdlib.h>


int main (int argc, char *argv[])
{
  char       strtime[256];
  struct tm  tt;
  int        i;
  int        n;

  if (argc != 2)
  {
    fprintf (stdout, "\nUsage: rand_dates.test number\n");
    return 1;
  }

  n = atoi(argv[1]);

  for (i=0; i<n; i++)
  {
    tt.tm_sec   = rand() % 60;
    tt.tm_min   = rand() % 60;
    tt.tm_hour  = rand() % 24;
    tt.tm_mday  = rand() % 28;
    tt.tm_mon   = rand() % 12;
    tt.tm_year  = (rand() % 130)+1;
    tt.tm_wday  = rand() % 7;
    tt.tm_yday  = rand() % 365;
    tt.tm_isdst = 0;

    strftime (strtime, 256, "%a %b %m %H:%M:%S MET DST %Y", &tt);
    fprintf (stdout, "\n./date2timestamp.test \"%s\" >> timestamps", strtime);
  }

  return 0;
}
