%{

int smtpwrap() { return 1; }

extern int smtplex();


/* -------------------------------------------------------- */
/* This function calls the flex parsed in order to scan the */
/* answer from the SMTP server. The returned value may be:  */
/* o 220                                                    */
/* o 350                                                    */
/* o 354                                                    */
/* o -1                                                     */
/* o 0 (if the input string is empty)                       */
/* -------------------------------------------------------- */

int smtp_yylex_memory (char *src)
{
  int             result;
  YY_BUFFER_STATE buf_state;

  buf_state = yy_scan_string(src);
  result = smtplex();
  yy_delete_buffer(buf_state);

  return result;
}



%}

ALPHA         ([A-Z]|[a-z])
NUMERIC       [0-9]
NOT_NUMERIC   [^0-9]
ALPHANUM      ({ALPHA}|{NUMERIC})

%%

^220\x20.*\r\n    { return 220; }
^250\x20.*\r\n    { return 250; }
^354\x20.*\r\n    { return 354; }
^.*               { return -1;  }
\n                { return -1;  }

%%

