#include <stdio.h>
#include "config.h"

extern struct parser_config  conf;
extern int                   line_conf_num;

int main (int argc, char *argv[])
{
  FILE *fd;
  int  status;
  char buffer[CONF_PARSING_ERROR_MESSAGE];

  if (argc != 2)
  {
    fprintf (stderr, "\nUsage: conf.test file_name\n");
    return 1;
  }

  fd = fopen (argv[1], "r");
  if (fd == NULL)
  {
    fprintf (stderr, "\nCan not open file %s\n", argv[1]);
    return 1;
  }

  status = read_conf(buffer, fd);

  if (status != CONF_OK)
  {
    fprintf (stderr, "\n%s\n", buffer);
    return 1;
  }

  fprintf (stdout, "\nConfig:\n");
  if (conf.output_mode == OUTFILE)
  { fprintf (stdout, "\noutput_mode = OUTFILE"); }
  if (conf.output_mode == OUTINFRANET)
  { fprintf (stdout, "\noutput_mode = OUTINFRANET"); }
  fprintf (stdout, "\npoid        [%s]", conf.poid);
  fprintf (stdout, "\nprog        [%s]", conf.prog);
  fprintf (stdout, "\ninput_file  [%s]", conf.input_file);
  fprintf (stdout, "\noutput_file [%s]", conf.output_file);
  fprintf (stdout, "\nfile_done   [%s]", conf.file_done);
  fprintf (stdout, "\nfile_reject [%s]", conf.file_reject);
  fprintf (stdout, "\nlog_file    [%s]", conf.log_file);
  fprintf (stdout, "\n\n");

  fclose (fd);

  return 0;
}
