#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "config.h"





int main (int argc, char *argv[])
{
  int  err, cr;
  char *value, tag[128]; 

  value = NULL;

  if (argc != 2)
  {
    fprintf (stderr, "Usage: config.test <path to configuration file>\n");
    return 1;
  }

  /* ------------------------------------------------- */
  /* Load configuration file                           */
  /* ------------------------------------------------- */

  cr = parse_configuration_file (argv[1], &err);

  if (cr != PARSE_CONFIGURATION_OK)
  {
    fprintf (stderr, "ERROR - %s\n", strerror(err));
    return 1;
  }

  /* ------------------------------------------------- */
  /* Look for values                                   */
  /* ------------------------------------------------- */

  strcpy (tag, "TAG1");
  cr = get_value (tag, &value);
  switch (cr)
  {
    case 0:  { fprintf (stdout, "Tag %s not found\n",   tag);        } break;
    case 1:  { fprintf (stdout, "Tag %s found => %s\n", tag, value); } break;
    case -1: { fprintf (stdout, "ERROR\n"); return 1;                }
  }

  strcpy (tag, "TAG2");
  cr = get_value (tag, &value);
  switch (cr)
  {
    case 0:  { fprintf (stdout, "Tag %s not found\n",   tag);        } break;
    case 1:  { fprintf (stdout, "Tag %s found => %s\n", tag, value); } break;
    case -1: { fprintf (stdout, "ERROR\n"); return 1;                }
  }

  strcpy (tag, "TAG3");
  cr = get_value (tag, &value);
  switch (cr)
  {
    case 0:  { fprintf (stdout, "Tag %s not found\n",   tag);        } break;
    case 1:  { fprintf (stdout, "Tag %s found => %s\n", tag, value); } break;
    case -1: { fprintf (stdout, "ERROR\n"); return 1;                }
  }

  strcpy (tag, "TAG4");
  cr = get_value (tag, &value);
  switch (cr)
  {
    case 0:  { fprintf (stdout, "Tag %s not found\n",   tag);        } break;
    case 1:  { fprintf (stdout, "Tag %s found => %s\n", tag, value); } break;
    case -1: { fprintf (stdout, "ERROR\n"); return 1;                }
  }

  strcpy (tag, "TAG5");
  cr = get_value (tag, &value);
  switch (cr)
  {
    case 0:  { fprintf (stdout, "Tag %s not found\n",   tag);        } break;
    case 1:  { fprintf (stdout, "Tag %s found => %s\n", tag, value); } break;
    case -1: { fprintf (stdout, "ERROR\n"); return 1;                }
  }


  return 0;
}
