#include <stdio.h>
#include "deamon.h"


int main()
{
  pid_t pid;
  int   rc;
  FILE  *OUT;

  fprintf (stdout, "Turn into deamon now\n"); fflush (stdout);

  rc = deamonizer(&pid, "/");

  if (pid < 0)
  {
    fprintf (stderr, "[FATAL] Father: Could not fork()!\n");
    return 1;
  }

  /* -------------------------------------------- */
  /* For the father, the operation is successful  */
  /* -------------------------------------------- */

  if (pid > 0)
  {
    fprintf (stdout, "[INFO] Father: operation successful, I exit now\n"); fflush (stdout);
    return 0;
  }

  /* -------------------------------------------- */
  /* For the child, we may have errors            */
  /* -------------------------------------------- */

  if (rc == 1)
  {
    fprintf (stderr, "[FATAL] Clild: Some initialization errors occured\n");
    return 1;
  }

  /* -------------------------------------------- */
  /* At this point the child is up and running as */
  /* a deamon.                                    */
  /* -------------------------------------------- */

  OUT = fopen ("/tmp/deamon.log", "w");
  if (OUT == NULL) { return 1; }

  fprintf (OUT, "Child deamon: waiting 10 seconds and die\n");

  fclose (OUT);

  sleep (10);

  return 0;
}
